/*	
 *	clipppui.h
 *
 *	P/ECE PPU (RICOH RP2C02) Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Sun Jan 30 21:25:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */

/****************************************************************************
 *
 ****************************************************************************/

/* * PPUG~[V́ABG`֐̎ɗp܂B
 * - void ppu_draw_chr      (int xpos, int ypos, int code, int palno)
 * - void ppu_draw_chr_revx (int xpos, int ypos, int code, int palno)
 * - void ppu_draw_chr_revy (int xpos, int ypos, int code, int palno)
 * - void ppu_draw_chr_revxy(int xpos, int ypos, int code, int palno)
 */
#ifdef PPU_DRAW_CHR_IMPLEMENT
{
	PPU* p_ppu = &ppu;
	unsigned char* vram = ppu_vram;
	//
	unsigned char* vbuff = p_ppu->vbuff;
	int scan_start = p_ppu->scan_start;
	int scan_end = p_ppu->scan_end;
	unsigned char* clut = p_ppu->clut;
	//
	int x;
	int y;
	int v;
	int v0;
	int v1;
	unsigned char* pattern;

	if(xpos <=          0 - 8 || xpos >=      256 ||
	   ypos <= scan_start - 8 || ypos >= scan_end) {
		return;
	}

	vbuff += ypos << 8 | xpos;
	palno <<= 2;
#if(PPU_REVY == 0)
	pattern = &vram[0x0000 | code << 4];
#else /*PPU_REVY*/
	pattern = &vram[0x0000 | code << 4] + 7;
#endif /*PPU_REVY*/

	if(xpos >=          0 && xpos <=      256 - 8 &&
	   ypos >= scan_start && ypos <= scan_end - 8) {
		for(y = 0; y < 8; y++) {
#if(PPU_REVX == 0)
			v0 = MIRROR(pattern[0]);
			v1 = MIRROR(pattern[8]) << 1;
#else /*PPU_REVX*/
			v0 = pattern[0];
			v1 = pattern[8] << 1;
#endif /*PPU_REVX*/
			for(x = 0; x < 8; x++) {
				v = (v0 & 1) | (v1 & 2);
				if(v) {
					*vbuff = clut[palno | v];
				}
				vbuff++;
				v0 >>= 1;
				v1 >>= 1;
			}
			vbuff += 256 - 8;
#if(PPU_REVY == 0)
			pattern++;
#else /*PPU_REVY*/
			pattern--;
#endif /*PPU_REVY*/
		}
	} else {
		for(y = 0; y < 8; y++) {
#if(PPU_REVX == 0)
			v0 = MIRROR(pattern[0]);
			v1 = MIRROR(pattern[8]) << 1;
#else /*PPU_REVX*/
			v0 = pattern[0];
			v1 = pattern[8] << 1;
#endif /*PPU_REVX*/
			for(x = 0; x < 8; x++) {
				v = (v0 & 1) | (v1 & 2);
				if(v) {
					if(xpos >=          0 && xpos <      256 &&
					   ypos >= scan_start && ypos < scan_end) {
						*vbuff = clut[palno | v];
					}
				}
				vbuff++;
				v0 >>= 1;
				v1 >>= 1;
				xpos += 1;
			}
			vbuff += 256 - 8;
#if(PPU_REVY == 0)
			pattern++;
#else /*PPU_REVY*/
			pattern--;
#endif /*PPU_REVY*/
			xpos -= 8;
			ypos += 1;
		}
	}
}
#endif PPU_DRAW_CHR_IMPLEMENT

/****************************************************************************
 *
 ****************************************************************************/
